﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace WinPhoneFtp.DemoApp
{
    public partial class Authenticate : PhoneApplicationPage
    {
        public Authenticate()
        {
            InitializeComponent();
        }

        protected override void OnNavigatingFrom(NavigatingCancelEventArgs e)
        {
            rdbtnAuthAnonymous.IsEnabled = true;
            rdbtnAuthAnonymous.IsEnabled = true;
            SystemTray.ProgressIndicator = null;
            base.OnNavigatingFrom(e);
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            while (this.NavigationService.CanGoBack)
            {
                this.NavigationService.RemoveBackEntry();
            }
        }

        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            base.OnBackKeyPress(e);
        }

        private async void appbarbtnAuthenticate_Click(object sender, EventArgs e)
        {
            if (rdbtnAuthAnonymous.IsChecked.HasValue && rdbtnAuthAnonymous.IsChecked.Value)
            {
                rdbtnAuthAnonymous.IsEnabled = false;
                rdbtnAuthCredentials.IsEnabled = false;
                rdbtnAuthCredentials.IsChecked = false;
                rdbtnAuthAnonymous.IsChecked = false;
                SystemTray.ProgressIndicator = new ProgressIndicator() { IsIndeterminate = true, Text = "Authenticating . . ." };
                await (App.Current as App).Client.AuthenticateAsync();
                return;
            }

            if (rdbtnAuthCredentials.IsChecked.HasValue && rdbtnAuthCredentials.IsChecked.Value)
            {
                rdbtnAuthAnonymous.IsEnabled = false;
                rdbtnAuthCredentials.IsEnabled = false;
                rdbtnAuthCredentials.IsChecked = false;
                rdbtnAuthAnonymous.IsChecked = false;
                SystemTray.ProgressIndicator = new ProgressIndicator() { IsIndeterminate = true, Text = "Authenticating . . ." };
                await (App.Current as App).Client.AuthenticateAsync(txtUsername.Text, pwdPassword.Password);
                return;
            }
        }

        private void rdbtnAuthCredentials_Checked(object sender, RoutedEventArgs e)
        {
            txtUsername.IsEnabled = true;
            pwdPassword.IsEnabled = true;
        }

        private void rdbtnAuthCredentials_Unchecked(object sender, RoutedEventArgs e)
        {
            txtUsername.IsEnabled = false;
            pwdPassword.IsEnabled = false;
        }
    }
}