﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace WinPhoneFtp.DemoApp
{
    public partial class Connect : PhoneApplicationPage
    {
        public Connect()
        {
            InitializeComponent();
        }

        protected override void OnNavigatingFrom(NavigatingCancelEventArgs e)
        {
            txtFtpServerIp.IsEnabled = true;
            txtPortNumber.IsEnabled = true;
            SystemTray.ProgressIndicator = null;
            base.OnNavigatingFrom(e);            
        }

        private async void appbarbtnConnect_Click(object sender, EventArgs e)
        {
            if (txtFtpServerIp.Text.Equals(String.Empty))
            {
                MessageBox.Show("FTP Server IP/Hostname cannot be empty", "FTP Demo App", MessageBoxButton.OK);
                txtFtpServerIp.Focus();
                return;
            }

            Int32 PortNumber = 0;
            if (txtPortNumber.Text.Equals(String.Empty) || !Int32.TryParse(txtPortNumber.Text, out PortNumber))
            {
                MessageBox.Show("Either the port number is empty or is not a valid port number", "FTP Demo App", MessageBoxButton.OK);
                txtPortNumber.Focus();
                return;
            }

            txtFtpServerIp.IsEnabled = false;
            txtPortNumber.IsEnabled = false;
            SystemTray.ProgressIndicator = new ProgressIndicator() { IsIndeterminate = true, Text = "Connecting . . ." };
            await (App.Current as App).ConnectToFtpServer(txtFtpServerIp.Text, txtPortNumber.Text);
        }
    }
}